import 'dart:convert';

class HeatmapData {
  final Map<int, Map<int, int>> data;

  const HeatmapData({
    required this.data,
  });

  factory HeatmapData.fromJson(Map<String, dynamic>? json) {
    Map<int, Map<int, int>> data = {};

    if (json?['heatmap'] != null) {
      json?['heatmap'].keys.forEach((day) {
        Map<String, dynamic> rawDataForThisDay = json['heatmap'][day];

        Map<int, int> dataForThisDay = {};
        rawDataForThisDay.keys.forEach((hour) {
          dataForThisDay[int.parse(hour)] = int.parse(rawDataForThisDay[hour].toString());
        });

        data[int.parse(day)] = dataForThisDay;
      });
    }

    return HeatmapData(data: data);
  }

  Map<String, dynamic> toJson() {
    Map<String, Map<String, int>> map = {};

    this.data.keys.forEach((day) {
      Map<String, int> dayMap = {};
      this.data[day]?.forEach((hour, count) {
        dayMap[hour.toString()] = count;
      });
      map[day.toString()] = dayMap;
    });

    return {'heatmap': map};
  }

  String toString() {
    return jsonEncode(this.toJson());
  }
}
